<template>
    <div class="form-group">
        <label v-if="props.showLabel">CUIL</label>
        <input type="text" v-model.trim="form.cuil.cuil" class="form-control text-center" placeholder="99-99999999-9"
            :class="{ 'is-invalid': !data.esValido }" :disabled="props.disabled" :required="props.required"
            :autocomplete="props.autocomplete" :id="props.id" v-maska data-maska="##-########-#" />
    </div>
</template>


<script setup lang="ts">

import { onMounted, computed, ref, reactive, watch, watchEffect } from "vue";
import Cuil from "./Cuil";
import { vMaska } from "maska";
import { isEmpty, isNumber } from "../../index";


const props = withDefaults(defineProps<{
    modelValue: Cuil,
    nroDoc?: string,
    validate?: boolean,
    showLabel?: boolean,
    disabled?: boolean,
    required?: boolean,
    autocomplete?: string
    id?: string
}>(), {
    modelValue: () => new Cuil(),
    nroDoc: undefined,
    validate: true,
    showLabel: true,
    disabled: false,
    required: true,
    autocomplete: "off",
    id: "inputCuil"
});

const emits = defineEmits<{
    (event: "update:modelValue", value: Cuil): void
}>();

const data = reactive({
    esValido: true as boolean
});

const form = reactive({
    cuil: computed({
        get() {
            return props.modelValue;
        },
        set(value) {
            emits('update:modelValue', value);
        }
    })
});

watch(computed(() => form.cuil.getCuil()), (newValue, oldValue) => {
    if (newValue !== oldValue && props.validate) {
        data.esValido = form.cuil.validarCuil(props.nroDoc);
    } else {
        data.esValido = true;
    }
});

onMounted(() => {
    if (isEmpty(form.cuil.getCuil()) && !isEmpty(props.nroDoc)) {
        form.cuil.setCuil("20" + props.nroDoc + "0");
    }
    if (props.validate) {
        data.esValido = form.cuil.validarCuil(props.nroDoc);
    } else {
        data.esValido = true;
    }
});

</script>
<style scope lang="scss">
.is-invalid {
    border-color: #dc3545 !important;
    padding-right: calc(1.5em + 0.75rem) !important;
    background-image: url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 12 12' width='12' height='12' fill='none' stroke='%23dc3545'%3e%3ccircle cx='6' cy='6' r='4.5'/%3e%3cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3e%3ccircle cx='6' cy='8.2' r='.6' fill='%23dc3545' stroke='none'/%3e%3c/svg%3e") !important;
    background-repeat: no-repeat !important;
    background-position: right calc(0.375em + 0.1875rem) center !important;
    background-size: calc(0.75em + 0.375rem) calc(0.75em + 0.375rem) !important;
}
</style>